package edinet_services.client;

import java.awt.Dimension;
import java.awt.Toolkit;

import java.io.File;

import javax.swing.JFrame;
import javax.swing.UIManager;

public class EdinetServicesClient {
  public EdinetServicesClient() {
    JFrame frame = new FrameMain();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation( ( screenSize.width - frameSize.width ) / 2, ( screenSize.height - frameSize.height ) / 2 );
    frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    frame.setVisible(true);
  }

  public static void main(String[] args) {
    try {
      //loadLibraries();
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (Exception e) {
      e.printStackTrace();
    }
    new EdinetServicesClient();
  }
  
  private static void loadLibraries() {
    File dir = new File("lib");
    System.setProperty("java.library.path", dir.getAbsolutePath());
    File libs[] = dir.listFiles();
    String lib = "";
    for (int i=0; i<libs.length; i++) try {
      lib = libs[i].getName();
      System.loadLibrary(lib);
    }
    catch (Exception ex) {
      System.out.print(lib+" loadin error: "+ex.getMessage());
      ex.printStackTrace(System.out);
    }
  }
}
