package edinet_services.client;

import com.infinite.utils.checksum.ChecksumHelper;

import edinet_services.services.MessageInputSimple.*;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.StringWriter;

import java.security.NoSuchAlgorithmException;

import javax.activation.DataHandler;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;


public class FrameMessageInput extends JFrame {
  private JButton jbSendMsg = new JButton();
  private JTextField jtfURL = new JTextField();
  private JLabel URLLabel = new JLabel();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JTextArea jtaMsg = new JTextArea();
  private JLabel jLabel1 = new JLabel();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea jTextAreaResponse = new JTextArea();
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JTextArea jtaRepMsg = new JTextArea();

  private JTextField jtfProxyHost = new JTextField();
  private JTextField jtfProxyPort = new JTextField();

  private JLabel jLabel3 = new JLabel();
  private JLabel jLabel4 = new JLabel();
  private JTextField jtfUsername = new JTextField();
  private JPasswordField jpfPassword = new JPasswordField();
  private JLabel jLabel5 = new JLabel();
  private JComboBox jcbChecksum = new JComboBox();

  private JSeparator jSeparator1 = new JSeparator();
  private JSeparator jSeparator2 = new JSeparator();
  private JTextArea jtaLogs = new JTextArea();
  private JLabel jLabel6 = new JLabel();
  private JLabel jLabel7 = new JLabel();

  private JTextField jtfMsgFmt = new JTextField();
  private JLabel jLabel9 = new JLabel();

  private JCheckBox jcbCleanLogsOnSend = new JCheckBox();


  private JLabel jLabel10 = new JLabel();


  private JTextField jtfParams = new JTextField();

  private JTextField jtfNonProxyHosts = new JTextField();

  private JLabel jLabel8 = new JLabel();
  private JButton jbSetLoc = new JButton();
  private JComboBox jcbLocations = new JComboBox();
  private JTextField jtfMsgId = new JTextField();
  private JSeparator jSeparator3 = new JSeparator();
  private JLabel jLabel2 = new JLabel();

  public FrameMessageInput() {
    try {
      jbInit();
      loadChcecksumAlgs();
      loadLocations();
      displayProxySettings();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout( null );
    this.setSize(new Dimension(472, 470));
    this.setTitle("EDInet services MessageInputSimple test client");
    jbSendMsg.setText("Send message");
    jbSendMsg.setBounds(new Rectangle(85, 250, 140, 20));
    jbSendMsg.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jButton1_actionPerformed();
          }
        });
    jtfURL.setBounds(new Rectangle(85, 10, 365, 20));
    jtfURL.setText("http://edinet.infinite.pl/edinet_services/services/MessageInputSimple");
    URLLabel.setText("URL");
    URLLabel.setBounds(new Rectangle(25, 10, 50, 20));
    URLLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    jScrollPane1.setBounds(new Rectangle(85, 140, 365, 55));
    jtaMsg.setText("test message");
    jLabel1.setText("Message:");
    jLabel1.setBounds(new Rectangle(5, 150, 70, 15));
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jScrollPane2.setBounds(new Rectangle(85, 335, 365, 50));
    jScrollPane3.setBounds(new Rectangle(85, 390, 365, 50));
    jtaRepMsg.setEditable(false);
    jtfProxyHost.setBounds(new Rectangle(85, 35, 100, 20));
    jtfProxyHost.setEnabled(false);
    jtfProxyHost.setToolTipText("-Dhttp.proxyHost");
    jtfProxyPort.setBounds(new Rectangle(190, 35, 60, 20));
    jtfProxyPort.setEnabled(false);
    jtfProxyPort.setToolTipText("-Dhttp.proxyPort");
    jLabel3.setText("Username:");
    jLabel3.setBounds(new Rectangle(10, 60, 70, 15));
    jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel4.setText("Password:");
    jLabel4.setBounds(new Rectangle(5, 85, 75, 15));
    jLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
    jtfUsername.setBounds(new Rectangle(85, 60, 365, 20));
    jtfUsername.setText("test");
    jpfPassword.setBounds(new Rectangle(85, 85, 365, 20));
    jpfPassword.setText("test");
    jLabel5.setText("Chcecksum:");
    jLabel5.setBounds(new Rectangle(5, 225, 75, 15));
    jLabel5.setHorizontalAlignment(SwingConstants.RIGHT);
    jcbChecksum.setBounds(new Rectangle(85, 225, 365, 20));
    jSeparator1.setBounds(new Rectangle(15, 275, 435, 2));
    jSeparator2.setBounds(new Rectangle(15, 330, 435, 2));
    jtaLogs.setEditable(false);
    jLabel6.setText("Logs:");
    jLabel6.setBounds(new Rectangle(15, 340, 65, 15));
    jLabel6.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel7.setText("Resp. msg.:");
    jLabel7.setBounds(new Rectangle(15, 390, 70, 15));
    jLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
    jtfMsgFmt.setBounds(new Rectangle(85, 115, 365, 20));
    jtfMsgFmt.setText("TEST");
    jLabel9.setText("Message fmt.:");
    jLabel9.setBounds(new Rectangle(0, 125, 80, 15));
    jLabel9.setHorizontalAlignment(SwingConstants.RIGHT);
    jcbCleanLogsOnSend.setText("Clean logs on send");
    jcbCleanLogsOnSend.setBounds(new Rectangle(235, 250, 150, 20));
    jcbCleanLogsOnSend.setSelected(true);
    jLabel10.setText("Parameters:");
    jLabel10.setBounds(new Rectangle(10, 200, 70, 15));
    jLabel10.setHorizontalAlignment(SwingConstants.RIGHT);
    jtfParams.setBounds(new Rectangle(85, 200, 365, 20));
    jtfParams.setToolTipText("| separated properties");
    jtfNonProxyHosts.setBounds(new Rectangle(255, 35, 195, 20));
    jtfNonProxyHosts.setEnabled(false);
    jtfNonProxyHosts.setToolTipText("-Dhttp.nonProxyHosts");
    jLabel8.setText("Proxy prop.:");
    jLabel8.setBounds(new Rectangle(10, 35, 70, 15));
    jLabel8.setHorizontalAlignment(SwingConstants.RIGHT);
    jbSetLoc.setText("Set message location");
    jbSetLoc.setBounds(new Rectangle(85, 305, 140, 20));
    jbSetLoc.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jbSetLoc_actionPerformed(e);
          }
        });
    jcbLocations.setBounds(new Rectangle(230, 305, 220, 20));
    jtfMsgId.setBounds(new Rectangle(85, 280, 365, 20));
    jSeparator3.setBounds(new Rectangle(15, 110, 445, 5));
    jLabel2.setText("Message Id");
    jLabel2.setBounds(new Rectangle(0, 285, 80, 15));
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jSeparator3, null);
    this.getContentPane().add(jtfMsgId, null);
    this.getContentPane().add(jcbLocations, null);
    this.getContentPane().add(jbSetLoc, null);
    this.getContentPane().add(jLabel8, null);
    this.getContentPane().add(jtfNonProxyHosts, null);
    this.getContentPane().add(jtfParams, null);
    this.getContentPane().add(jLabel10, null);
    this.getContentPane().add(jcbCleanLogsOnSend, null);
    this.getContentPane().add(jLabel9, null);
    this.getContentPane().add(jtfMsgFmt, null);
    this.getContentPane().add(jLabel7, null);
    this.getContentPane().add(jLabel6, null);
    this.getContentPane().add(jSeparator2, null);
    this.getContentPane().add(jSeparator1, null);
    this.getContentPane().add(jcbChecksum, null);
    this.getContentPane().add(jLabel5, null);
    this.getContentPane().add(jpfPassword, null);
    this.getContentPane().add(jtfUsername, null);
    this.getContentPane().add(jLabel4, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(jtfProxyPort, null);
    this.getContentPane().add(jtfProxyHost, null);
    jScrollPane3.getViewport().add(jTextAreaResponse, null);
    jScrollPane3.getViewport().add(jtaRepMsg, null);
    this.getContentPane().add(jScrollPane3, null);
    this.getContentPane().add(jLabel1, null);
    jScrollPane1.getViewport().add(jtaMsg, null);
    this.getContentPane().add(jScrollPane1, null);
    this.getContentPane().add(URLLabel, null);
    this.getContentPane().add(jtfURL, null);
    this.getContentPane().add(jbSendMsg, null);
    jScrollPane2.getViewport().add(jtaLogs, null);
    this.getContentPane().add(jScrollPane2, null);
  }

  private void displayProxySettings(){
    jtfProxyHost.setText(System.getProperty("http.proxyHost"));
    jtfProxyPort.setText(System.getProperty("http.proxyPort"));
    jtfNonProxyHosts.setText(System.getProperty("http.nonProxyHosts"));
  }
  
  private void jButton1_actionPerformed() {
    sendMessage();
  }
  
  private void loadChcecksumAlgs() {
    jcbChecksum.addItem("<NONE>");
    jcbChecksum.addItem("CRC32");
    jcbChecksum.addItem("MD5");
    jcbChecksum.addItem("SHA1");
    jcbChecksum.setSelectedIndex(3);
  }
  
  private void loadLocations() {
    jcbLocations.addItem("ZADANIA RECEPIT (51)");
    jcbLocations.addItem("ZADANIA DELIVERED (52)");
    jcbLocations.addItem("ZADANIA NONDELIVERED (53)");
    jcbLocations.setSelectedIndex(0);
  }
  
  private String getMessageStr() {
    return this.jtaMsg.getText();
  }

  private InputStream getMessageStream() {
    return new ByteArrayInputStream(getMessageStr().getBytes());
  }

  private void setRespMessage(DataHandler dh) throws IOException {
    this.jtaRepMsg.setText("");
    if (dh!=null) {
      InputStream is = dh.getInputStream();
      byte [] buf = new byte[1024];
      int len;
      while ((len = is.read(buf))!=-1) {
        this.jtaRepMsg.append(new String(buf,0,len));
      }
    }
  }

  private void cleanResp() {
    this.jtaRepMsg.setText("");
    this.jtaRepMsg.update(this.jtaRepMsg.getGraphics());
  }

  private void setRespMessage(String msg) throws IOException {
    this.jtaRepMsg.setText(msg);
  }

  private String getChecksumAlg(){
    String alg = null;
    int si = jcbChecksum.getSelectedIndex();
    if (si>0) {
      alg = (String)jcbChecksum.getSelectedItem();
    }
    return alg;
  }
  
  private String computeChecksum() throws IOException, 
                                          NoSuchAlgorithmException {
    String alg = getChecksumAlg();
    String cs = null;
    if (alg!=null) {
      cs = ChecksumHelper.computeChecksum(getMessageStream(),alg);
    }
    return cs;
  }
  
  private void sendMessage() {
    // przygotowanie logow
    if (this.jcbCleanLogsOnSend.isSelected()) {
      clearLogs();
    }
    // wynik
    cleanResp();
    
    // pozyskanie klasy MessageInput
    MessageInputSimpleServiceLocator loc = new MessageInputSimpleServiceLocator();
    loc.setMessageInputSimpleEndpointAddress(this.jtfURL.getText());
    MessageInputSimple mi;
    try {
      mi = loc.getMessageInputSimple();
      // obliczenie sumy kontrolnej
      String alg = getChecksumAlg();
      String cs = computeChecksum();
      // przygotowanie komunikatu
      writeLog("Sending message, checksum "+alg+": "+cs+"...");
      // wywolanie zdalne
      String resp = mi.putMessage(
        this.jtfUsername.getText(),
        new String(jpfPassword.getPassword()), //hack warning!
        this.jtfMsgFmt.getText(),
        getMessageStr().getBytes(),
        "text/plain",
        jtfParams.getText(),
        alg,
        cs
      );
      writeLog("done.");
      // wyswietlenie odpowiedzi
      setRespMessage(resp);
    }
    catch (Exception e) {
      writeLog(e);
    }
  }
  private int getLoc(){
    String loc = null;
    int si = jcbLocations.getSelectedIndex();
    loc = (String)jcbLocations.getSelectedItem();
    if (loc.equalsIgnoreCase("ZADANIA RECEPIT (51)")){
        return 51;
    }else if (loc.equalsIgnoreCase("ZADANIA DELIVERED (52)")){
        return 52;
    }else if (loc.equalsIgnoreCase("ZADANIA NONDELIVERED (53)")){
        return 53;      
    }else{
      return 0;  
    }
  }
  private void setMessageLocation() {
    // przygotowanie logow
    if (this.jcbCleanLogsOnSend.isSelected()) {
      clearLogs();
    }
    // wynik
    cleanResp();
    
    // pozyskanie klasy MessageInput
    MessageInputSimpleServiceLocator loc = new MessageInputSimpleServiceLocator();
    loc.setMessageInputSimpleEndpointAddress(this.jtfURL.getText());
    MessageInputSimple mi;
    try {
      mi = loc.getMessageInputSimple();
      int location=getLoc();
      // przygotowanie komunikatu
      writeLog("Setting location, msgId:"+jtfMsgId.getText()+", location:"+Integer.toString(location)+"...");
      // wywolanie zdalne
      String resp = mi.setMessageLocation(
        this.jtfUsername.getText(),
        new String(jpfPassword.getPassword()), //hack warning!
        jtfMsgId.getText(),
        location
      );
      writeLog("done.");
      // wyswietlenie odpowiedzi
      setRespMessage(resp);
    }
    catch (Exception e) {
      writeLog(e);
    }
  }


  public void clearLogs() {
    this.jtaLogs.setText("");
    this.jtaLogs.update(this.jtaLogs.getGraphics());
  }
  public void writeLog(String message) {
    this.jtaLogs.append(message+"\n");
  }
  public void writeLog(Exception e) {
    try {
       StringWriter sw = new StringWriter();
       e.printStackTrace(new PrintWriter(sw));
       writeLog( "------\n" + sw.toString() + "------\n");
     }
     catch( Exception e2) {
       writeLog(e.toString()+": "+e.getMessage());
     }
  }

  private void jbSetLoc_actionPerformed(ActionEvent e) {
    setMessageLocation();
  }
}
