package edinet_services.client;

import com.infinite.utils.checksum.ChecksumHelper;

import edinet_services.services.MessageOutputSimple.*;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.StringWriter;

import java.security.NoSuchAlgorithmException;

import javax.activation.DataHandler;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;


public class FrameMessageOutput extends JFrame {
  private JButton jbGetMsg = new JButton();
  private JTextField jtfURL = new JTextField();
  private JLabel URLLabel = new JLabel();
  private JLabel jLabel1 = new JLabel();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea jTextAreaResponse = new JTextArea();
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JTextArea jtaRepMsg = new JTextArea();

  private JTextField jtfProxyHost = new JTextField();
  private JTextField jtfProxyPort = new JTextField();

  private JLabel jLabel3 = new JLabel();
  private JLabel jLabel4 = new JLabel();
  private JTextField jtfUsername = new JTextField();
  private JPasswordField jpfPassword = new JPasswordField();

  private JSeparator jSeparator1 = new JSeparator();
  private JSeparator jSeparator2 = new JSeparator();
  private JTextArea jtaLogs = new JTextArea();
  private JLabel jLabel6 = new JLabel();
  private JLabel jLabel7 = new JLabel();


  private JCheckBox jcbCleanLogsOnSend = new JCheckBox();


  private JTextField jtfNonProxyHosts = new JTextField();

  private JLabel jLabel8 = new JLabel();
  private JTextField jtfMsgId = new JTextField();
  private JButton jbGetStatus = new JButton();
  private JComboBox jCBDocTypes = new JComboBox();
  private JLabel jLabel2 = new JLabel();
  private JButton jbGetList = new JButton();
  private JSeparator jSeparator3 = new JSeparator();

  public FrameMessageOutput() {
    try {
      jbInit();
      displayProxySettings();
      loadDocumentTypes();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout( null );
    this.setSize(new Dimension(472, 470));
    this.setTitle("EDInet services MessageOutputSimple test client");
    jbGetMsg.setText("Get message");
    jbGetMsg.setBounds(new Rectangle(5, 180, 100, 25));
    jbGetMsg.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jButton1_actionPerformed();
          }
        });
    jtfURL.setBounds(new Rectangle(85, 10, 365, 20));
    jtfURL.setText("http://edinet.infinite.pl/edinet_services/services/MessageOutputSimple");
    URLLabel.setText("URL");
    URLLabel.setBounds(new Rectangle(25, 10, 50, 20));
    URLLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel1.setText("Message Id");
    jLabel1.setBounds(new Rectangle(10, 120, 70, 15));
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jScrollPane2.setBounds(new Rectangle(85, 220, 365, 70));
    jScrollPane3.setBounds(new Rectangle(85, 295, 365, 140));
    jtaRepMsg.setEditable(false);
    jtfProxyHost.setBounds(new Rectangle(85, 35, 100, 20));
    jtfProxyHost.setEnabled(false);
    jtfProxyHost.setToolTipText("-Dhttp.proxyHost");
    jtfProxyPort.setBounds(new Rectangle(190, 35, 60, 20));
    jtfProxyPort.setEnabled(false);
    jtfProxyPort.setToolTipText("-Dhttp.proxyPort");
    jLabel3.setText("Username:");
    jLabel3.setBounds(new Rectangle(10, 60, 70, 15));
    jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel4.setText("Password:");
    jLabel4.setBounds(new Rectangle(5, 85, 75, 15));
    jLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
    jtfUsername.setBounds(new Rectangle(85, 60, 365, 20));
    jtfUsername.setText("test");
    jpfPassword.setBounds(new Rectangle(85, 85, 365, 20));
    jpfPassword.setText("test");
    jSeparator1.setBounds(new Rectangle(10, 170, 435, 5));
    jSeparator2.setBounds(new Rectangle(15, 210, 435, 2));
    jtaLogs.setEditable(false);
    jLabel6.setText("Logs:");
    jLabel6.setBounds(new Rectangle(10, 240, 65, 15));
    jLabel6.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel7.setText("Resp. msg.:");
    jLabel7.setBounds(new Rectangle(5, 330, 70, 15));
    jLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
    jcbCleanLogsOnSend.setText("Clean logs on send");
    jcbCleanLogsOnSend.setBounds(new Rectangle(350, 185, 115, 20));
    jcbCleanLogsOnSend.setSelected(true);
    jtfNonProxyHosts.setBounds(new Rectangle(255, 35, 195, 20));
    jtfNonProxyHosts.setEnabled(false);
    jtfNonProxyHosts.setToolTipText("-Dhttp.nonProxyHosts");
    jLabel8.setText("Proxy prop.:");
    jLabel8.setBounds(new Rectangle(10, 35, 70, 15));
    jLabel8.setHorizontalAlignment(SwingConstants.RIGHT);
    jtfMsgId.setBounds(new Rectangle(85, 120, 365, 20));
    jbGetStatus.setText("Get Status");
    jbGetStatus.setBounds(new Rectangle(250, 180, 95, 25));
    jbGetStatus.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jbGetStatus_actionPerformed(e);
          }
        });
    jCBDocTypes.setBounds(new Rectangle(85, 145, 365, 20));
    jLabel2.setText("Message Type");
    jLabel2.setBounds(new Rectangle(0, 140, 80, 25));
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jbGetList.setText("Get Messages List");
    jbGetList.setBounds(new Rectangle(110, 180, 135, 25));
    jbGetList.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jbGetList_actionPerformed(e);
          }
        });
    jSeparator3.setBounds(new Rectangle(10, 110, 445, 2));
    this.getContentPane().add(jSeparator3, null);
    this.getContentPane().add(jbGetList, null);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jCBDocTypes, null);
    this.getContentPane().add(jbGetStatus, null);
    this.getContentPane().add(jtfMsgId, null);
    this.getContentPane().add(jLabel8, null);
    this.getContentPane().add(jtfNonProxyHosts, null);
    this.getContentPane().add(jcbCleanLogsOnSend, null);
    this.getContentPane().add(jLabel7, null);
    this.getContentPane().add(jLabel6, null);
    this.getContentPane().add(jSeparator2, null);
    this.getContentPane().add(jSeparator1, null);
    this.getContentPane().add(jpfPassword, null);
    this.getContentPane().add(jtfUsername, null);
    this.getContentPane().add(jLabel4, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(jtfProxyPort, null);
    this.getContentPane().add(jtfProxyHost, null);
    this.getContentPane().add(jScrollPane3, null);
    this.getContentPane().add(jLabel1, null);
    jScrollPane3.getViewport().add(jTextAreaResponse, null);
    jScrollPane3.getViewport().add(jtaRepMsg, null);
    this.getContentPane().add(URLLabel, null);
    this.getContentPane().add(jtfURL, null);
    this.getContentPane().add(jbGetMsg, null);
    jScrollPane2.getViewport().add(jtaLogs, null);
    this.getContentPane().add(jScrollPane2, null);
  }

  private void displayProxySettings(){
    jtfProxyHost.setText(System.getProperty("http.proxyHost"));
    jtfProxyPort.setText(System.getProperty("http.proxyPort"));
    jtfNonProxyHosts.setText(System.getProperty("http.nonProxyHosts"));
  }
  
  private void jButton1_actionPerformed() {
    sendGetMessage();
  }
  
    private void jbGetStatus_actionPerformed(ActionEvent e) {
      sendGetMessageStatus();
    }
  
  private void jbGetList_actionPerformed(ActionEvent e) {
    sendGetMessageList();
  }

  private void setRespMessage(DataHandler dh) throws IOException {
    this.jtaRepMsg.setText("");
    if (dh!=null) {
      InputStream is = dh.getInputStream();
      byte [] buf = new byte[1024];
      int len;
      while ((len = is.read(buf))!=-1) {
        this.jtaRepMsg.append(new String(buf,0,len));
      }
    }
  }

  private void cleanResp() {
    this.jtaRepMsg.setText("");
    this.jtaRepMsg.update(this.jtaRepMsg.getGraphics());
  }

  private void setRespMessage(String msg) throws IOException {
    this.jtaRepMsg.setText(msg);
  }

  private void loadDocumentTypes(){
    jCBDocTypes.addItem("<NONE>");
    jCBDocTypes.addItem("ORDER");
    jCBDocTypes.addItem("INVOICE");
    jCBDocTypes.addItem("EINVOICE");
  }
  
  private String getDocumentType(){
    String type = null;
    int si = jCBDocTypes.getSelectedIndex();
    if (si>0) {
      type = (String)jCBDocTypes.getSelectedItem();
    }
    return type;
  }
  
  private void sendGetMessageStatus() {
    // przygotowanie logow
    if (this.jcbCleanLogsOnSend.isSelected()) {
      clearLogs();
    }
    // wynik
    cleanResp();
    
    // pozyskanie klasy MessageOutput
    MessageOutputSimpleServiceLocator loc = new MessageOutputSimpleServiceLocator();
    loc.setMessageOutputSimpleEndpointAddress(this.jtfURL.getText());
    MessageOutputSimple mo;
    try {
      mo = loc.getMessageOutputSimple();
      // przygotowanie komunikatu
      writeLog("Sending Get message status, user "+jtfUsername.getText()+", msgId "+jtfMsgId.getText()+"...");
      // wywolanie zdalne
      String resp = mo.getMessageStatus(
        this.jtfUsername.getText(),
        new String(jpfPassword.getPassword()), //hack warning!        
        this.jtfMsgId.getText()
      );
      writeLog("done.");
      // wyswietlenie odpowiedzi
      setRespMessage(resp);
    }
    catch (Exception e) {
      writeLog(e);
    }
  }
  
  private void sendGetMessage() {
    // przygotowanie logow
    if (this.jcbCleanLogsOnSend.isSelected()) {
      clearLogs();
    }
    // wynik
    cleanResp();
    
    // pozyskanie klasy MessageOutput
    MessageOutputSimpleServiceLocator loc = new MessageOutputSimpleServiceLocator();
    loc.setMessageOutputSimpleEndpointAddress(this.jtfURL.getText());
    MessageOutputSimple mo;
    try {
      mo = loc.getMessageOutputSimple();
      // przygotowanie komunikatu
      writeLog("Sending Get message, user "+jtfUsername.getText()+", msgId "+jtfMsgId.getText()+", docType "+getDocumentType()+"...");
      // wywolanie zdalne
       byte[] resp = mo.getMessage(
        this.jtfUsername.getText(),
        new String(jpfPassword.getPassword()), //hack warning!
        getDocumentType(),
        this.jtfMsgId.getText()
      );
      writeLog("done.");
      // wyswietlenie odpowiedzi
      if (resp!=null)
        setRespMessage(new String(resp));
    }
    catch (Exception e) {
      writeLog(e);
    }
  }
  
  private void sendGetMessageList() {
    // przygotowanie logow
    if (this.jcbCleanLogsOnSend.isSelected()) {
      clearLogs();
    }
    // wynik
    cleanResp();
    
    // pozyskanie klasy MessageOutput
    MessageOutputSimpleServiceLocator loc = new MessageOutputSimpleServiceLocator();
    loc.setMessageOutputSimpleEndpointAddress(this.jtfURL.getText());
    MessageOutputSimple mo;
    try {
      mo = loc.getMessageOutputSimple();
      // przygotowanie komunikatu
      writeLog("Sending Get list of available messages , user "+jtfUsername.getText()+", docType "+getDocumentType()+"...");
      // wywolanie zdalne
       String resp = mo.getAvailableMsgList(
        this.jtfUsername.getText(),
        new String(jpfPassword.getPassword()), //hack warning!
        getDocumentType()
      );
      writeLog("done.");
      // wyswietlenie odpowiedzi
      setRespMessage(resp);
    }
    catch (Exception e) {
      writeLog(e);
    }
  }
  
  
  public void clearLogs() {
    this.jtaLogs.setText("");
    this.jtaLogs.update(this.jtaLogs.getGraphics());
  }
  public void writeLog(String message) {
    this.jtaLogs.append(message+"\n");
  }
  public void writeLog(Exception e) {
    try {
       StringWriter sw = new StringWriter();
       e.printStackTrace(new PrintWriter(sw));
       writeLog( "------\n" + sw.toString() + "------\n");
     }
     catch( Exception e2) {
       writeLog(e.toString()+": "+e.getMessage());
     }
  }


  
}
